#include <boost/locale.hpp> // boost::locale::generator

#include <cassert> // assert

#include <Shlwapi.h> // PathRemoveFileSpec
#include <Winbase.h> // GetModuleFileName

#pragma comment(lib, "shlwapi.lib")

BOOL APIENTRY DllMain( HMODULE hModule,
                       DWORD  ul_reason_for_call,
                       LPVOID lpReserved
					 )
{
	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
		{
			try
			{
				// Initialise Boost.Locale translation mechanism
				boost::locale::generator gen;

				char path[MAX_PATH];
				::GetModuleFileNameA(NULL, path, MAX_PATH);

				assert(::PathRemoveFileSpecA(path));
				gen.add_messages_path(path);

				gen.add_messages_domain("local_test");

				std::locale::global(gen("nl")); // default locale
			}
			catch (std::exception) { /* ignore */ }
		}
	case DLL_THREAD_ATTACH:
	case DLL_THREAD_DETACH:
	case DLL_PROCESS_DETACH:
		//std::locale::global(std::locale::classic());
		break;
	}
    return TRUE;
}
